select recv.SID_CORPORATE
	, recv.SID_USER
	, recv.ID
	, recv.fromid
	, recv.kind
	, recv.open
	, recv.cretime
	, '1'::char as add_ntwi
	, (CASE WHEN g.ID is not null AND (uset.nodispitem LIKE '%Group%' OR uset.nodispitem LIKE '%assign%') is not true
	  THEN report.entryname || ' [' || g.Name || ']'
	  ELSE report.entryname END) as fromname
	from TTPR_CRT_RECV recv
		left outer join TT_CRT report ON recv.SID_CORPORATE = report.SID_CORPORATE AND recv.ID = report.ID AND recv.fromid = report.entry
		left outer join TM_USER u ON u.SID_CORPORATE = report.SID_CORPORATE AND u.ID = report.entry
		left outer join TM_GROUP g ON g.SID_CORPORATE = u.SID_CORPORATE AND g.ID = u.defgroup
		left outer join TM_USET_SETTING uset ON uset.SID_CORPORATE = report.SID_CORPORATE
	where recv.SID_CORPORATE=1 AND recv.kind is null
union
select SID_CORPORATE
	, SID_USER
	, ID
	, fromid
	, kind
	, open
	, cretime
	, '1'::char as add_ntwi
	, fromname
	from TTPR_CRT_RECV
	where SID_CORPORATE=1 AND kind is not null
order by
	SID_CORPORATE, SID_USER, ID
