select SID_CORPORATE
	, CAST(NULL AS numeric) as SID_GROUP
	, ID
	, CAST(NULL AS numeric) as SID_ROUTE
	, CAST(NULL AS numeric) as SID_PROUTE
	, SEQNO
	, SID_USER_ROUTE
	, '0' as ROUTE_TYPE
	, NULL as Name 
	, '0' as decvkind
	, CAST(NULL AS numeric) as rtnpoint
	, '2' as ROUTE_CLASS
	, CAST(NULL AS numeric(9)) as SID_GROUP_ROUTE
	, CAST('2' AS char(1)) as ROUTE_CLASS_KIND
	, CAST(NULL AS varchar(127)) as ROUTE_CLASS_NAME
	, CAST(NULL AS char(1)) as authkind
	, CAST(NULL AS numeric(9)) as SID_ROLE_AUTHKIND
	, CAST(NULL AS numeric(2)) as hierarchy
	from TM_FLW_TEMPLATE_ROUTE  -- 経路設定ルート
	where SID_CORPORATE=1
union all
select SID_CORPORATE
	, NULL as SID_GROUP
	, ID
	, NULL as SID_ROUTE
	, NULL as SID_PROUTE
	, SID_ROUTE as SEQNO
	, NULL as SID_USER_ROUTE
	, '1' as ROUTE_TYPE 
	, decvgname as Name 
	, decvkind
	, rtnpoint
	, '2' as ROUTE_CLASS
	, CAST(NULL AS numeric(9)) as SID_GROUP_ROUTE
	, CAST('2' AS char(1)) as ROUTE_CLASS_KIND
	, CAST(NULL AS varchar(127)) as ROUTE_CLASS_NAME
	, CAST(NULL AS char(1)) as authkind
	, CAST(NULL AS numeric(9)) as SID_ROLE_AUTHKIND
	, CAST(NULL AS numeric(2)) as hierarchy
	from TM_FLW_TEMPLATE_ROUTE_GROUP -- 経路設定ルート（承認グループ）
	where SID_CORPORATE=1
union all
select SID_CORPORATE
	, NULL as SID_GROUP
	, ID
	, NULL as SID_ROUTE
	, CAST(0 AS numeric) as SID_PROUTE
	, SID_ROUTE as SEQNO
	, SID_USER_ROUTE
	, '0' as ROUTE_TYPE 
	, NULL as Name
	, '0' as decvkind
	, NULL as rtnpoint
	, '1' as ROUTE_CLASS
	, CAST(NULL AS numeric(9)) as SID_GROUP_ROUTE
	, CAST('1' AS char(1)) as ROUTE_CLASS_KIND
	, CAST(NULL AS varchar(127)) as ROUTE_CLASS_NAME
	, CAST(NULL AS char(1)) as authkind
	, CAST(NULL AS numeric(9)) as SID_ROLE_AUTHKIND
	, CAST(NULL AS numeric(2)) as hierarchy
	from TM_FLW_TEMPLATE_ROUTE_GUSER -- 経路設定ルート（承認グループメンバー）
	where SID_CORPORATE=1
union all
select SID_CORPORATE
	, SID_GROUP
	, ID
	, NULL as SID_ROUTE
	, NULL as SID_PROUTE
	, SEQNO
	, SID_USER_ROUTE
	, '0' as ROUTE_TYPE
	, NULL as Name 
	, '0' as decvkind
	, NULL as rtnpoint
	, '2' as ROUTE_CLASS
	, CAST(NULL AS numeric(9)) as SID_GROUP_ROUTE
	, CAST('2' AS char(1)) as ROUTE_CLASS_KIND
	, CAST(NULL AS varchar(127)) as ROUTE_CLASS_NAME
	, CAST(NULL AS char(1)) as authkind
	, CAST(NULL AS numeric(9)) as SID_ROLE_AUTHKIND
	, CAST(NULL AS numeric(2)) as hierarchy
	from TM_FLW_GROUP_TEMPLATE_ROUTE -- グループ経路設定ルート
	where SID_CORPORATE=1
union all
select SID_CORPORATE
	, SID_GROUP
	, ID
	, NULL as SID_ROUTE
	, NULL as SID_PROUTE
	, SID_ROUTE as SEQNO
	, NULL as SID_USER_ROUTE
	, '1' as ROUTE_TYPE 
	, decvgname as Name 
	, decvkind
	, rtnpoint
	, '2' as ROUTE_CLASS
	, CAST(NULL AS numeric(9)) as SID_GROUP_ROUTE
	, CAST('2' AS char(1)) as ROUTE_CLASS_KIND
	, CAST(NULL AS varchar(127)) as ROUTE_CLASS_NAME
	, CAST(NULL AS char(1)) as authkind
	, CAST(NULL AS numeric(9)) as SID_ROLE_AUTHKIND
	, CAST(NULL AS numeric(2)) as hierarchy
	from TM_FLW_GTEMPLATE_ROUTE_GRP -- グループ経路設定ルート（承認グループ）
	where SID_CORPORATE=1
union all
select SID_CORPORATE
	, SID_GROUP
	, ID
	, NULL as SID_ROUTE
	, CAST(0 AS numeric) as SID_PROUTE
	, SID_ROUTE as SEQNO
	, SID_USER_ROUTE
	, '0' as ROUTE_TYPE 
	, NULL as Name
	, '0' as decvkind
	, NULL as rtnpoint
	, '1' as ROUTE_CLASS
	, CAST(NULL AS numeric(9)) as SID_GROUP_ROUTE
	, CAST('1' AS char(1)) as ROUTE_CLASS_KIND
	, CAST(NULL AS varchar(127)) as ROUTE_CLASS_NAME
	, CAST(NULL AS char(1)) as authkind
	, CAST(NULL AS numeric(9)) as SID_ROLE_AUTHKIND
	, CAST(NULL AS numeric(2)) as hierarchy
	from TM_FLW_GTEMPLATE_ROUTE_GUSER -- グループ経路設定ルート（承認グループメンバー）
	where SID_CORPORATE=1
order by SID_CORPORATE
	, SID_GROUP
	, ID
	, SEQNO
	, ROUTE_TYPE DESC

