select 
	ko.SID_CORPORATE 
,	ko.SID_USER 
,	ko.SID_KOUBAI 
,	ko.closedate 
,	ko.ID 
,	ko.amount
,	ko.entrydate 
,	ko.deldate 
,	(CASE WHEN k.endtime >= '2400' THEN '2'
          WHEN k.endtime < '0900' THEN '1' 
           ELSE '0' END) as backdate 
,	(CASE WHEN repeat = '6' THEN 'w'
          WHEN repeat = '5' and intervalkind = 'd' THEN 'd' 
          WHEN repeat = '5' and intervalkind = 'w' THEN 'w' 
          WHEN repeat = '5' and intervalkind = 'm' THEN 'm' 
           ELSE NULL END) as repeat 
from 
	TTPR_KOBAI_ORDER ko 
join 
	TT_KOBAI k 
on 
	ko.SID_CORPORATE = k.SID_CORPORATE 
and 
	ko.SID_KOUBAI = k.ID 
where 
	ko.SID_CORPORATE=1 
and 
	(COALESCE(k.repeat,'0')!='5' OR COALESCE(k.intervalkind,'0')!='m' OR extract(day from to_timestamp(k.startdate, 'YYYYMMDD')) < 29) 
order by 
	ko.SID_CORPORATE, ko.SID_KOUBAI, ko.ID, ko.closedate, ko.SID_USER 
;
