select 
	SID_CORPORATE 
,	ID 
,	startdate 
,	starttime 
,	COALESCE(enddate, '20371231') as enddate 
,	endtime 
,	detail 
,	memo 
,	addshohin 
,	sdispdate 
,	sdisptime 
,	(CASE WHEN repeat = '6' THEN 'w'
          WHEN repeat = '5' and intervalkind = 'd' THEN 'd' 
          WHEN repeat = '5' and intervalkind = 'w' and interval < 15 THEN 'd' 
          WHEN repeat = '5' and intervalkind = 'w' and interval >= 15 THEN 'w' 
          WHEN repeat = '5' and intervalkind = 'm' THEN 'm' 
           ELSE NULL END) as repeat
,	(CASE WHEN repeat = '6' THEN 1
          WHEN repeat = '5' and intervalkind = 'w' and interval < 15 THEN interval*7
           ELSE interval END) as interval
,	(CASE WHEN repeat = '6' THEN week
          WHEN repeat = '5' and intervalkind = 'w' and interval >= 15
              THEN (CASE extract(dow from to_timestamp(startdate, 'YYYYMMDD'))
                                     WHEN 0 THEN '0000001'
                                     WHEN 1 THEN '1000000'
                                     WHEN 2 THEN '0100000'
                                     WHEN 3 THEN '0010000'
                                     WHEN 4 THEN '0001000'
                                     WHEN 5 THEN '0000100'
                                     WHEN 6 THEN '0000010'
                                     ELSE NULL END)
           ELSE NULL END) as everyweekday
,	holiday 
,	entry 
,	'JST     ' as SID_TZ 
,	'0' as overday 
,	'0' as dst_min 
from 
	TT_KOBAI 
where 
	SID_CORPORATE=1 
and 
	(COALESCE(repeat,'0')!='5' OR COALESCE(intervalkind,'0')!='m' OR extract(day from to_timestamp(startdate, 'YYYYMMDD')) < 29) 
order by 
	SID_CORPORATE, ID 
;
