select 
	sts.SID_CORPORATE 
,	sts.SID_KOUBAI 
,	sts.ID 
,	sts.closedate 
,	sts.status 
,	sts.price 
,	sts.tax 
,	(CASE WHEN k.endtime >= '2400' THEN '2'
          WHEN k.endtime < '0900' THEN '1' 
           ELSE '0' END) as backdate 
,	(CASE WHEN repeat = '6' THEN 'w'
          WHEN repeat = '5' and intervalkind = 'd' THEN 'd' 
          WHEN repeat = '5' and intervalkind = 'w' THEN 'w' 
          WHEN repeat = '5' and intervalkind = 'm' THEN 'm' 
           ELSE NULL END) as repeat 
from
	TT_KOBAI_SHSTS sts 
join
	TT_KOBAI k 
on 
	sts.SID_CORPORATE = k.SID_CORPORATE 
and 
	sts.SID_KOUBAI = k.ID 
where 
	sts.SID_CORPORATE=1 
and 
	(COALESCE(k.repeat,'0')!='5' OR COALESCE(k.intervalkind,'0')!='m' OR extract(day from to_timestamp(k.startdate, 'YYYYMMDD')) < 29) 
order by 
	sts.SID_CORPORATE, sts.SID_KOUBAI, sts.ID, sts.closedate 
;
