select 
	t.SID_CORPORATE
,	t.SID_PROJECT
,	t.ID
,	t.TITLE
,	t.STARTDATE
,	t.ENDDATE
,	t.SID_USER_ENTRY
,	t.COMPLETE
,	r.RATE
,	r.MAXID as LASTID
,	r.MAXID as CURRENTID
,	t.MEMO
,	t.CHIEF
,	t.BUDGET
,	t.STAFF
 from
	TT_PRJ_TASK t
	left outer join
	(select 
		a.SID_CORPORATE
	,	a.SID_PROJECT
	,	a.SID_TASK
	,	a.MAXID
	,	b.RATE
	 from
		(select 
			SID_CORPORATE
		,	SID_PROJECT
		,	SID_TASK
		,	MAX(ID) as MAXID
		 from
			TT_PRJ_REPORT
		  group by
			SID_CORPORATE
		,	SID_PROJECT
		,	SID_TASK
		) a
		inner join
		TT_PRJ_REPORT b
		on a.SID_CORPORATE=b.SID_CORPORATE
		 and a.SID_PROJECT=b.SID_PROJECT
		 and a.SID_TASK=b.SID_TASK
		 and a.MAXID=b.ID
	) r
	on t.SID_CORPORATE=r.SID_CORPORATE
	 and t.SID_PROJECT=r.SID_PROJECT
	 and t.ID=r.SID_TASK
  where
	t.SID_CORPORATE=1
   order by
	SID_PROJECT
,	STARTDATE
,	TITLE;