select 
   SID_CORPORATE
 , SID_MODULE
 , ID
 , SID_ASSIGN
 , accesskind
 from
   TMPR_ACCESS_USER
 where
     SID_CORPORATE =1
 and SID_MODULE = 1
 
 union all
 
 select 
   a.SID_CORPORATE
 , a.SID_MODULE
 , a.ID
 , b.SID_ASSIGN
 ,   CAST(MAX(CASE WHEN a.accesskind > 0             THEN 1 ELSE 0 END) as numeric(2))
   + CAST(MAX(CASE WHEN a.accesskind in (3,7,11,15)  THEN 2 ELSE 0 END) as numeric(2))
   + CAST(MAX(CASE WHEN a.accesskind in (5,7,13,15)  THEN 4 ELSE 0 END) as numeric(2))
   + CAST(MAX(CASE WHEN a.accesskind in (9,11,13,15) THEN 8 ELSE 0 END) as numeric(2)) AS accesskind
 from
   TMPR_ACCESS_PRGROUP a
 inner join TMPR_GROUP_USER b
 on  a.SID_CORPORATE = b.SID_CORPORATE
 and a.ID = b.SID_USER
 and a.SID_ASSIGN = b.ID
 left  join TMPR_ACCESS_USER c
 on  b.SID_CORPORATE = c.SID_CORPORATE
 and b.SID_USER = c.ID
 and b.SID_ASSIGN = c.SID_ASSIGN
 where
     a.SID_CORPORATE = 1
 and a.SID_MODULE = 1
 and c.SID_ASSIGN is null
 group by
   a.SID_CORPORATE
 , a.SID_MODULE
 , a.ID
 , b.SID_ASSIGN
 ;

