SELECT 
	a.SID_CORPORATE AS SID_CORPORATE
,	a.ID AS ID
,	a.subject AS subject
,	a.STATUS AS STATUS
,	(CASE WHEN a.stype = 'u' THEN 
	    SUBSTR(b.startdate,3,6) || LPAD(CAST(b.SID_USER AS CHAR(10)),6,'0') || LPAD(CAST(b.ID AS CHAR(10)),5,'0') || '1'
	 WHEN a.stype = 'g' THEN
	    SUBSTR(c.startdate,3,6) || LPAD(CAST(c.SID_GROUP AS CHAR(10)),6,'0') || LPAD(CAST(c.ID AS CHAR(10)),5,'0') || '2'
	 WHEN a.stype = 'p' THEN
	    SUBSTR(d.startdate,3,6) || LPAD(CAST(d.SID_PLANT AS CHAR(10)),6,'0') || LPAD(CAST(d.ID AS CHAR(10)),5,'0') || '4'
	 ELSE NULL END) AS sid
,	a.schseldate AS startdate
,	(CASE
		WHEN a.stype = 'u' THEN b.starttime
		WHEN a.stype = 'g' THEN c.starttime
		WHEN a.stype = 'p' THEN d.starttime
		ELSE NULL END) AS starttime
,	(CASE
		WHEN a.stype = 'u' THEN b.endtime
		WHEN a.stype = 'g' THEN c.endtime
		WHEN a.stype = 'p' THEN d.endtime
		ELSE NULL END) AS endtime
,	(CASE
		WHEN a.stype = 'u' THEN
			(CASE	WHEN b.repeat = '1'                          THEN 'd'
					WHEN b.repeat = '2' and b.everyweek =  '0'   THEN 'w'
					WHEN b.repeat = '2' and b.everyweek <> '0'   THEN 'm'
					WHEN b.repeat = '3'                          THEN 'm'
					WHEN b.repeat = '4'                          THEN 'r'
					WHEN b.repeat = '5' and b.intervalkind = 'd' THEN 'd'
					WHEN b.repeat = '5' and b.intervalkind = 'w' THEN 'w'
					WHEN b.repeat = '5' and b.intervalkind = 'm' THEN 'm'
					WHEN b.repeat = '5' and b.intervalkind = 'y' THEN 'y' ELSE NULL END)
		WHEN a.stype = 'g' THEN
			(CASE	WHEN c.repeat = '1'                          THEN 'd'
					WHEN c.repeat = '2' and c.everyweek =  '0'   THEN 'w'
					WHEN c.repeat = '2' and c.everyweek <> '0'   THEN 'm'
					WHEN c.repeat = '3'                          THEN 'm'
					WHEN c.repeat = '4'                          THEN 'r'
					WHEN c.repeat = '5' and c.intervalkind = 'd' THEN 'd'
					WHEN c.repeat = '5' and c.intervalkind = 'w' THEN 'w'
					WHEN c.repeat = '5' and c.intervalkind = 'm' THEN 'm'
					WHEN c.repeat = '5' and c.intervalkind = 'y' THEN 'y' ELSE NULL END)
		WHEN a.stype = 'p' THEN
			(CASE	WHEN d.repeat = '1'                          THEN 'd'
					WHEN d.repeat = '2' and d.everyweek =  '0'   THEN 'w'
					WHEN d.repeat = '2' and d.everyweek <> '0'   THEN 'm'
					WHEN d.repeat = '3'                          THEN 'm'
					WHEN d.repeat = '4'                          THEN 'r'
					WHEN d.repeat = '5' and d.intervalkind = 'd' THEN 'd'
					WHEN d.repeat = '5' and d.intervalkind = 'w' THEN 'w'
					WHEN d.repeat = '5' and d.intervalkind = 'm' THEN 'm'
					WHEN d.repeat = '5' and d.intervalkind = 'y' THEN 'y' ELSE NULL END)
		ELSE NULL END) AS repeat
,	replace(a.mailto,'"','') AS mailto
,	a.entry AS entry
,	a.entryname AS entryname
,	a.entrykana AS entrykana
,	a.updateuser AS updateuser
,	a.updname AS updname
,	a.updkana AS updkana
,	a.entrydate AS entrydate
,	a.entrytime AS entrytime
,	a.updatedate AS updatedate
,	a.updatetime AS updatetime
,	a.memo AS memo
,	a.circleopen AS circleopen
,	NULL AS cid
,	a.docsave AS docsave
,	NULL AS dfid
,	NULL AS did
,	a.modstatus AS modstatus
,	a.modlogin AS modlogin
 FROM
	TT_AGENDA a 
	LEFT JOIN TTPR_SCHEDULE b ON a.SID_CORPORATE = b.SID_CORPORATE AND a.sid = b.ID AND a.stargetid = b.SID_USER AND b.SID_CORPORATE = 1 AND b.agenda = '1' AND a.stype = 'u' and b.startdate > '19700102' and b.startdate < '21000101' and not(b.enddate IS NULL and b.startdate > '20371231')
	LEFT JOIN TT_SCH_GROUP c ON a.SID_CORPORATE = c.SID_CORPORATE AND a.sid = c.ID AND a.stargetid = c.SID_GROUP AND c.SID_CORPORATE = 1 AND c.agenda = '1' AND a.stype = 'g' and c.startdate > '19700102' and c.startdate < '21000101' and not(c.enddate IS NULL and c.startdate > '20371231')
	LEFT JOIN TT_PLT_SCHEDULE d ON a.SID_CORPORATE = d.SID_CORPORATE AND a.sid = d.ID AND a.stargetid = d.SID_PLANT AND d.SID_CORPORATE = 1 AND d.agenda = '1' AND a.stype = 'p' and d.startdate > '19700102' and d.startdate < '21000101' and not(d.enddate IS NULL and d.startdate > '20371231')
 WHERE a.SID_CORPORATE = 1;
