select 
     SID_CORPORATE
 ,   ID
 ,   SID_ATTACH
 ,   FILENAME
 ,   DISPNAME
 ,   MIMETYPE
 ,   ORG_ID
 ,   SID_ASSIGN
 ,   SID_USER
 ,   KBN
 ,   LOG_KBN
 ,   LOG_TID
 ,   LOG_SID_PRGROUP
 ,   LOG_SCH_ID
 ,   LOG_startdate
 ,   LOG_starttime
 ,   event
 ,   detail
 ,   DISPNAME AS logtitle
 from
     (
     -- ユーザスケジュール
     select
         ATTACH.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_USER as varchar), 6, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 5, '0') || '1' AS ID
     ,   ATTACH.SID_ATTACH
     ,   ATTACH.FILENAME
     ,   ATTACH.DISPNAME
     ,   ATTACH.MIMETYPE
     ,   SCHEDULE.ID AS ORG_ID
     ,   SCHEDULE.SID_USER AS SID_ASSIGN
     ,   CAST(NULL as numeric(9)) AS SID_USER
     ,   CAST('1' as char(1))  AS KBN
     ,   CAST('User Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_USER     AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     from
         TTPR_ATTACH_SCHEDULE ATTACH
     inner join TTPR_SCHEDULE SCHEDULE
     on  ATTACH.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and ATTACH.SID_USER      = SCHEDULE.SID_USER
     and ATTACH.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and SCHEDULE.srctype IS NULL
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')

     union all

     -- グループスケジュール
     select
         ATTACH.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_GROUP as varchar), 6, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 5, '0') || '2' AS ID
     ,   ATTACH.SID_ATTACH
     ,   ATTACH.FILENAME
     ,   ATTACH.DISPNAME
     ,   ATTACH.MIMETYPE
     ,   SCHEDULE.ID AS ORG_ID
     ,   SCHEDULE.SID_GROUP AS SID_ASSIGN
     ,   CAST(NULL as numeric(9)) AS SID_USER
     ,   CAST('2' as char(1))  AS KBN
     ,   CAST('Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_GROUP    AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     from
         TT_ATTACH_SCH_GROUP ATTACH
     inner join TT_SCH_GROUP SCHEDULE
     on  ATTACH.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and ATTACH.SID_GROUP     = SCHEDULE.SID_GROUP
     and ATTACH.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and SCHEDULE.srctype IS NULL
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')

     union all

     -- 個人グループスケジュール
     select
         ATTACH.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_USER as varchar), 6, '0') || LPAD(CAST(SCHEDULE.SID_PRGROUP as varchar), 2, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 3, '0') || '3' AS ID
     ,   ATTACH.SID_ATTACH
     ,   ATTACH.FILENAME
     ,   ATTACH.DISPNAME
     ,   ATTACH.MIMETYPE
     ,   SCHEDULE.ID AS ORG_ID
     ,   SCHEDULE.SID_PRGROUP AS SID_PRGROUP
     ,   SCHEDULE.SID_USER AS SID_USER
     ,   CAST('3' as char(1))  AS KBN
     ,   CAST('User Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_USER     AS LOG_TID
     ,   SCHEDULE.SID_PRGROUP  AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     from
         TTPR_ATTACH_SCH_GROUP ATTACH
     inner join TTPR_SCH_GROUP SCHEDULE
     on  ATTACH.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and ATTACH.SID_USER      = SCHEDULE.SID_USER
     and ATTACH.SID_PRGROUP   = SCHEDULE.SID_PRGROUP
     and ATTACH.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and SCHEDULE.srctype IS NULL
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')

     union all

     -- 設備予約
     select
         ATTACH.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_PLANT as varchar), 6, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 5, '0') || '4' AS ID
     ,   ATTACH.SID_ATTACH
     ,   ATTACH.FILENAME
     ,   ATTACH.DISPNAME
     ,   ATTACH.MIMETYPE
     ,   SCHEDULE.ID AS ORG_ID
     ,   SCHEDULE.SID_PLANT AS SID_ASSIGN
     ,   CAST(NULL as numeric(9)) AS SID_USER
     ,   CAST('4' as char(1))  AS KBN
     ,   CAST('Plant Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_PLANT    AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     from
         TT_ATTACH_PLT_SCHEDULE ATTACH
     inner join TT_PLT_SCHEDULE SCHEDULE
     on  ATTACH.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and ATTACH.SID_PLANT     = SCHEDULE.SID_PLANT
     and ATTACH.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and SCHEDULE.srctype IS NULL
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')
     ) alias
