select 
     SID_CORPORATE
 ,   ID
 ,   (CASE WHEN repeat = '3' THEN
           (CASE WHEN everymonth > 31 THEN TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as timestamp) + '1 months' + '-1 days', 'YYYYMMDD')
                 WHEN TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as date) + CAST(everymonth as int) - 1, 'YYYYMM') <> SUBSTRING(startdate, 1, 6) THEN TO_CHAR(CAST(CAST(SUBSTRING(startdate, 1, 6) || '01' as timestamp) + '1 months' as date) + CAST(everymonth as int) - 1, 'YYYYMMDD')
                 ELSE TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as date) + CAST(everymonth as int) - 1, 'YYYYMMDD') END)
           ELSE startdate END) AS startdate
 ,   (CASE WHEN repeat IN ('1', '2', '3') and repeatlimit = '1' THEN '2037/12/31'
           WHEN repeat = '4' THEN CAST(REP_MAX_SID_ASSIGN as char(8)) 
           ELSE enddate END) AS enddate
 ,   starttime
 ,   endtime
 ,   memo
 ,   openlevel
 ,   rankflg
 ,   reserve
 ,   CAST(
     (CASE WHEN repeat = '1'                        THEN 'd'
           WHEN repeat = '2' and everyweek =  0     THEN 'w'
           WHEN repeat = '2' and everyweek <> 0     THEN 'm'
           WHEN repeat = '3'                        THEN 'm'
           WHEN repeat = '4'                        THEN 'r'
           WHEN repeat = '5' and intervalkind = 'd' THEN 'd'
           WHEN repeat = '5' and intervalkind = 'w' THEN 'w'
           WHEN repeat = '5' and intervalkind = 'm' THEN 'm'
           WHEN repeat = '5' and intervalkind = 'y' THEN 'y' ELSE NULL END) as char(1)) as repeat
 ,   CAST((CASE WHEN everyweek = '5' THEN 9 ELSE everyweek END) as numeric(1)) as everyweek
 ,   CAST(
     (CASE WHEN repeat = '2' THEN 
                (CASE everyweekday WHEN '0' THEN '0000001'
                                   WHEN '1' THEN '1000000'
                                   WHEN '2' THEN '0100000'
                                   WHEN '3' THEN '0010000'
                                   WHEN '4' THEN '0001000'
                                   WHEN '5' THEN '0000100'
                                   WHEN '6' THEN '0000010'
                                   ELSE NULL END)
           WHEN repeat = '5' and intervalkind = 'w' THEN
                (CASE date_part('dow', cast(startdate as timestamp))
                                   WHEN 0 THEN '0000001'
                                   WHEN 1 THEN '1000000'
                                   WHEN 2 THEN '0100000'
                                   WHEN 3 THEN '0010000'
                                   WHEN 4 THEN '0001000'
                                   WHEN 5 THEN '0000100'
                                   WHEN 6 THEN '0000010'
                                   ELSE NULL END)
           ELSE NULL END) as char(7)) AS everyweekday
 ,   (CASE WHEN repeat = '1' THEN 1
           WHEN repeat = '2' THEN 1
           WHEN repeat = '3' THEN 1
           WHEN repeat = '4' THEN NULL
           WHEN repeat = '5' THEN CAST(interval as int) ELSE NULL END) as interval
 ,   CAST(NULL as numeric(3)) AS rependtimes
 ,   event
 ,   detail
 ,   place
 ,   other
 ,   outflg
 ,   iconno
 ,   flag
 ,   (CASE daycolor WHEN '#6464ff' THEN 1
                    WHEN '#64c864' THEN 2
                    WHEN '#ffd83c' THEN 3
                    WHEN '#e664e6' THEN 4
                    WHEN '#e64646' THEN 5
                    ELSE 1 END) as schcolor
 ,   entry
 ,   creuser
 ,   approvreq
 ,   aprvmailnotice
 ,   visitor
 ,   cretime
 ,   entrytime AS updtime
 ,   agenda
 ,   CAST('JST' as char(3)) as SID_TZ
 ,   LOG_KBN
 ,   LOG_TID
 ,   LOG_SID_PRGROUP
 ,   LOG_SCH_ID
 ,   startdate AS LOG_startdate
 ,   starttime AS LOG_starttime
 ,   '0' as dst_min
 from
     (
     select
         SID_CORPORATE
     ,   SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_USER as varchar), 6, '0') || LPAD(CAST(ID as varchar), 5, '0') || '1' AS ID
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   memo
     ,   openlevel
     ,   rankflg
     ,   reserve
     ,   repeat
     ,   everyweek
     ,   everyweekday
     ,   everymonth
     ,   repeatlimit
     ,   intervalkind
     ,   interval
     ,   event
     ,   detail
     ,   place
     ,   other
     ,   outflg
     ,   iconno
     ,   flag
     ,   daycolor
     ,   entry
     ,   creuser
     ,   approvreq
     ,   aprvmailnotice
     ,   visitor
     ,   cretime
     ,   entrytime
     ,   agenda
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('User Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_USER              AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     from
         TTPR_SCHEDULE SCH
     LEFT JOIN (
         SELECT
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_USER        AS REP_SID_USER
         ,   ID              AS REP_ID
         ,   MAX(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         FROM
             TTPR_SCH_REPDATE
         GROUP BY
             SID_CORPORATE
         ,   SID_USER
         ,   ID
         ) REP
     ON  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     AND SCH.SID_USER      = REP.REP_SID_USER
     AND SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and (   srctype IS NULL
         or  srctarget IS NULL
         or (srctype = 'u' and srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
         or (srctype = 'g' and srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
         or (srctype = 'p' and srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
         )
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')

     union all

     select
         SID_CORPORATE
     ,   SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_GROUP as varchar), 6, '0') || LPAD(CAST(ID as varchar), 5, '0') || '2' AS ID
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   memo
     ,   openlevel
     ,   rankflg
     ,   reserve
     ,   repeat
     ,   everyweek
     ,   everyweekday
     ,   everymonth
     ,   repeatlimit
     ,   intervalkind
     ,   interval
     ,   event
     ,   detail
     ,   place
     ,   other
     ,   outflg
     ,   iconno
     ,   flag
     ,   daycolor
     ,   entry
     ,   creuser
     ,   approvreq
     ,   aprvmailnotice
     ,   visitor
     ,   cretime
     ,   entrytime
     ,   agenda
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_GROUP             AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     from
         TT_SCH_GROUP SCH
     LEFT JOIN (
         SELECT
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_GROUP       AS REP_SID_GROUP
         ,   ID              AS REP_ID
         ,   MAX(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         FROM
             TT_SCH_GROUP_REPDATE
         GROUP BY
             SID_CORPORATE
         ,   SID_GROUP
         ,   ID
         ) REP
     ON  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     AND SCH.SID_GROUP     = REP.REP_SID_GROUP
     AND SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and (   srctype IS NULL
         or  srctarget IS NULL
         or (srctype = 'u' and srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
         or (srctype = 'g' and srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
         or (srctype = 'p' and srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
         )
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')

     union all

     select
         SID_CORPORATE
     ,   SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_USER as varchar), 6, '0') || LPAD(CAST(SID_PRGROUP as varchar), 2, '0') || LPAD(CAST(ID as varchar), 3, '0') || '3' AS ID
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   memo
     ,   openlevel
     ,   rankflg
     ,   reserve
     ,   repeat
     ,   everyweek
     ,   everyweekday
     ,   everymonth
     ,   repeatlimit
     ,   intervalkind
     ,   interval
     ,   event
     ,   detail
     ,   place
     ,   other
     ,   outflg
     ,   iconno
     ,   flag
     ,   daycolor
     ,   entry
     ,   creuser
     ,   approvreq
     ,   aprvmailnotice
     ,   CAST(NULL as numeric(9)) AS visitor
     ,   cretime
     ,   entrytime
     ,   agenda
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('User Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_USER              AS LOG_TID
     ,   SID_PRGROUP           AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     from
         TTPR_SCH_GROUP SCH
     LEFT JOIN (
         SELECT
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_USER        AS REP_SID_USER
         ,   SID_PRGROUP     AS REP_SID_PRGROUP
         ,   ID              AS REP_ID
         ,   MAX(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         FROM
             TTPR_SCH_GROUP_REPDATE
         GROUP BY
             SID_CORPORATE
         ,   SID_USER
         ,   SID_PRGROUP
         ,   ID
         ) REP
     ON  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     AND SCH.SID_USER      = REP.REP_SID_USER
     AND SCH.SID_PRGROUP   = REP.REP_SID_PRGROUP
     AND SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and srctype IS NULL
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')

     union all

     select
         SID_CORPORATE
     ,   SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_PLANT as varchar), 6, '0') || LPAD(CAST(ID as varchar), 5, '0') || '4' AS ID
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   memo
     ,   openlevel
     ,   rankflg
     ,   reserve
     ,   repeat
     ,   everyweek
     ,   everyweekday
     ,   everymonth
     ,   repeatlimit
     ,   intervalkind
     ,   interval
     ,   event
     ,   detail
     ,   place
     ,   other
     ,   outflg
     ,   iconno
     ,   flag
     ,   daycolor
     ,   entry
     ,   creuser
     ,   approvreq
     ,   aprvmailnotice
     ,   visitor
     ,   cretime
     ,   entrytime
     ,   agenda
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('Plant Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_PLANT             AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     from
         TT_PLT_SCHEDULE SCH
     LEFT JOIN (
         SELECT
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_PLANT       AS REP_SID_PLANT
         ,   ID              AS REP_ID
         ,   MAX(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         FROM
             TT_PLT_SCH_REPDATE
         GROUP BY
             SID_CORPORATE
         ,   SID_PLANT
         ,   ID
         ) REP
     ON  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     AND SCH.SID_PLANT     = REP.REP_SID_PLANT
     AND SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and (   srctype IS NULL
         or  srctarget IS NULL
         or (srctype = 'u' and srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
         or (srctype = 'g' and srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
         or (srctype = 'p' and srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
         )
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')
     ) alias
