select 
     SID_CORPORATE
 ,   ID
 ,   OTHERTO_TYPE
 ,   SID_ASSIGN
 ,   SID_USER
 ,   (CASE WHEN repeat = '3' THEN
           (CASE WHEN everymonth > 31 THEN TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as timestamp) + '1 months' + '-1 days', 'YYYYMMDD')
                 WHEN TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as date) + CAST(everymonth as int) - 1, 'YYYYMM') <> SUBSTRING(startdate, 1, 6) THEN TO_CHAR(CAST(CAST(SUBSTRING(startdate, 1, 6) || '01' as timestamp) + '1 months' as date) + CAST(everymonth as int) - 1, 'YYYYMMDD')
                 ELSE TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as date) + CAST(everymonth as int) - 1, 'YYYYMMDD') END)
           ELSE startdate END) AS startdate
 ,   (CASE WHEN repeat IN ('1', '2', '3') and repeatlimit = '1' THEN '2037/12/31'
           WHEN repeat = '4' THEN CAST(REP_MAX_SID_ASSIGN as char(8))
           ELSE enddate END) AS enddate
 ,   starttime
 ,   endtime
 ,   cretime
 ,   entrytime AS updtime
 ,   (CASE WHEN repeat = '1'                        THEN 'd'
           WHEN repeat = '2' and everyweek =  '0'   THEN 'w'
           WHEN repeat = '2' and everyweek <> '0'   THEN 'm'
           WHEN repeat = '3'                        THEN 'm'
           WHEN repeat = '4'                        THEN 'r'
           WHEN repeat = '5' and intervalkind = 'd' THEN 'd'
           WHEN repeat = '5' and intervalkind = 'w' THEN 'w'
           WHEN repeat = '5' and intervalkind = 'm' THEN 'm'
           WHEN repeat = '5' and intervalkind = 'y' THEN 'y' ELSE NULL END) AS repeat
 ,   LOG_KBN
 ,   LOG_TID
 ,   LOG_SID_PRGROUP
 ,   LOG_SCH_ID
 ,   startdate AS LOG_startdate
 ,   starttime AS LOG_starttime
 ,   event
 ,   detail
 from
     (
     -- ユーザスケジュール
     select
         SID_CORPORATE
     ,   (CASE WHEN srctype IS NULL
                or  srctarget IS NULL
                or (srctype = 'u' and srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
                or (srctype = 'g' and srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
                or (srctype = 'p' and srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
                                    THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_USER  as varchar), 6, '0') || LPAD(CAST(ID     as varchar), 5, '0') || '1'
               WHEN srctype = 'u'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '1'
               WHEN srctype = 'g'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '2'
               WHEN srctype = 'p'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '4'
               ELSE '' END) AS ID
     ,   'u'                        AS OTHERTO_TYPE
     ,   SID_USER                   AS SID_ASSIGN
     ,   CAST(NULL as numeric(9,0)) AS SID_USER
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   repeat
     ,   everyweek
     ,   intervalkind
     ,   everymonth
     ,   repeatlimit
     ,   cretime
     ,   entrytime
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('User Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_USER              AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     ,   event
     ,   detail
     from
         TTPR_SCHEDULE SCH
     left join (
         select
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_USER        AS REP_SID_USER
         ,   ID              AS REP_ID
         ,   max(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         from
             TTPR_SCH_REPDATE
         group by
             SID_CORPORATE
         ,   SID_USER
         ,   ID
         ) REP
     on  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     and SCH.SID_USER      = REP.REP_SID_USER
     and SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and (srctype IS NULL or srctarget IS NULL or srctype IN ('u', 'g', 'p'))
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')

     union all

     -- グループスケジュール
     select
         SID_CORPORATE
     ,   (CASE WHEN srctype IS NULL
                or  srctarget IS NULL
                or (srctype = 'u' and srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
                or (srctype = 'g' and srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
                or (srctype = 'p' and srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
                                    THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_GROUP as varchar), 6, '0') || LPAD(CAST(ID     as varchar), 5, '0') || '2'
               WHEN srctype = 'u'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '1'
               WHEN srctype = 'g'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '2'
               WHEN srctype = 'p'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '4'
               ELSE '' END) AS ID
     ,   'g'                        AS OTHERTO_TYPE
     ,   SID_GROUP                  AS SID_ASSIGN
     ,   CAST(NULL as numeric(9,0)) AS SID_USER
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   repeat
     ,   everyweek
     ,   intervalkind
     ,   everymonth
     ,   repeatlimit
     ,   cretime
     ,   entrytime
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_GROUP             AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     ,   event
     ,   detail
     from
         TT_SCH_GROUP SCH
     left join (
         select
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_GROUP       AS REP_SID_GROUP
         ,   ID              AS REP_ID
         ,   max(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         from
             TT_SCH_GROUP_REPDATE
         group by
             SID_CORPORATE
         ,   SID_GROUP
         ,   ID
         ) REP
     on  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     and SCH.SID_GROUP     = REP.REP_SID_GROUP
     and SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and (srctype IS NULL or srctarget IS NULL or srctype IN ('u', 'g', 'p'))
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')

     union all

     -- 個人グループスケジュール
     select
         SID_CORPORATE
     ,   SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_USER as varchar), 6, '0') || LPAD(CAST(SID_PRGROUP as varchar), 2, '0') || LPAD(CAST(ID as varchar), 3, '0') || '3' AS ID
     ,   'r'         AS OTHERTO_TYPE
     ,   SID_PRGROUP AS SID_ASSIGN
     ,   SID_USER
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   repeat
     ,   everyweek
     ,   intervalkind
     ,   everymonth
     ,   repeatlimit
     ,   cretime
     ,   entrytime
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('User Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_USER              AS LOG_TID
     ,   SID_PRGROUP           AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     ,   event
     ,   detail
     from
         TTPR_SCH_GROUP SCH
     left join (
         select
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_USER        AS REP_SID_USER
         ,   SID_PRGROUP     AS REP_SID_PRGROUP
         ,   ID              AS REP_ID
         ,   max(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         from
             TTPR_SCH_GROUP_REPDATE
         group by
             SID_CORPORATE
         ,   SID_USER
         ,   SID_PRGROUP
         ,   ID
         ) REP
     on  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     and SCH.SID_USER      = REP.REP_SID_USER
     and SCH.SID_PRGROUP   = REP.REP_SID_PRGROUP
     and SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and srctype IS NULL
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')

     union all

     -- 設備予約
     select
         SID_CORPORATE
     ,   (CASE WHEN srctype IS NULL
                or  srctarget IS NULL
                or (srctype = 'u' and srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
                or (srctype = 'g' and srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
                or (srctype = 'p' and srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
                                    THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(SID_PLANT as varchar), 6, '0') || LPAD(CAST(ID     as varchar), 5, '0') || '4'
               WHEN srctype = 'u'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '1'
               WHEN srctype = 'g'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '2'
               WHEN srctype = 'p'   THEN SUBSTRING(startdate,3, 6)||LPAD(CAST(srctarget as varchar), 6, '0') || LPAD(CAST(srcsid as varchar), 5, '0') || '4'
               ELSE '' END) AS ID
     ,   'p'                        AS OTHERTO_TYPE
     ,   SID_PLANT                  AS SID_ASSIGN
     ,   CAST(NULL as numeric(9,0)) AS SID_USER
     ,   startdate
     ,   enddate
     ,   starttime
     ,   endtime
     ,   repeat
     ,   everyweek
     ,   intervalkind
     ,   everymonth
     ,   repeatlimit
     ,   cretime
     ,   entrytime
     ,   REP.REP_MAX_SID_ASSIGN
     ,   CAST('Plant Schedule' as varchar(128)) AS LOG_KBN
     ,   SID_PLANT             AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   ID                    AS LOG_SCH_ID
     ,   event
     ,   detail
     from
         TT_PLT_SCHEDULE SCH
     left join (
         select
             SID_CORPORATE   AS REP_SID_CORPORATE
         ,   SID_PLANT       AS REP_SID_PLANT
         ,   ID              AS REP_ID
         ,   max(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
         from
             TT_PLT_SCH_REPDATE
         group by
             SID_CORPORATE
         ,   SID_PLANT
         ,   ID
         ) REP
     on  SCH.SID_CORPORATE = REP.REP_SID_CORPORATE
     and SCH.SID_PLANT     = REP.REP_SID_PLANT
     and SCH.ID            = REP.REP_ID
     where
         SID_CORPORATE = 1
     and (srctype IS NULL or srctarget IS NULL or srctype IN ('u', 'g', 'p'))
     and startdate > '19700102'
     and startdate < '21000101'
     and not(enddate IS NULL and startdate > '20371231')
     ) alias
