select 
     SCHEDULE.SID_CORPORATE
 ,   (CASE WHEN SCHEDULE.srctype IS NULL
            or  SCHEDULE.srctarget IS NULL
            or (SCHEDULE.srctype = 'u' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
            or (SCHEDULE.srctype = 'g' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
            or (SCHEDULE.srctype = 'p' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
                                         THEN SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_USER  as varchar), 6, '0') || LPAD(CAST(SCHEDULE.ID     as varchar), 5, '0') || '1'
           WHEN SCHEDULE.srctype = 'u'   THEN SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.srctarget as varchar), 6, '0') || LPAD(CAST(SCHEDULE.srcsid as varchar), 5, '0') || '1'
           WHEN SCHEDULE.srctype = 'g'   THEN SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.srctarget as varchar), 6, '0') || LPAD(CAST(SCHEDULE.srcsid as varchar), 5, '0') || '2'
           WHEN SCHEDULE.srctype = 'p'   THEN SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.srctarget as varchar), 6, '0') || LPAD(CAST(SCHEDULE.srcsid as varchar), 5, '0') || '4'
           ELSE '' END) AS ID
 ,   SCHEDULE.SID_USER AS SID_ASSIGN
 ,   SCHEDULE.approvsts
 ,   SCHEDULE.alarm
 ,   SCHEDULE.alarmtime
 ,   SCHEDULE.alarmcnt
 ,   SCHEDULE.cretime
 ,   SCHEDULE.entrytime AS updtime
 -- 付箋／アラーム設定用
 ,   (CASE WHEN repeat = '3' THEN
           (CASE WHEN everymonth > 31 THEN TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as timestamp) + '1 months' + '-1 days', 'YYYYMMDD')
                 WHEN TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as date) + CAST(everymonth as int) - 1, 'YYYYMM') <> SUBSTRING(startdate, 1, 6) THEN TO_CHAR(CAST(CAST(SUBSTRING(startdate, 1, 6) || '01' as timestamp) + '1 months' as date) + CAST(everymonth as int) - 1, 'YYYYMMDD')
                 ELSE TO_CHAR(CAST(SUBSTRING(startdate, 1, 6) || '01' as date) + CAST(everymonth as int) - 1, 'YYYYMMDD') END)
           ELSE startdate END) AS startdate
 ,   (CASE WHEN SCHEDULE.repeat IN ('1', '2', '3') and SCHEDULE.repeatlimit = '1' THEN '2037/12/31'
           WHEN SCHEDULE.repeat = '4' THEN CAST(REP.REP_MAX_SID_ASSIGN as char(8))
           ELSE SCHEDULE.enddate END)   AS enddate
 ,   SCHEDULE.starttime AS starttime
 ,   SCHEDULE.endtime   AS endtime
 ,   (CASE WHEN repeat = '1'                        THEN 'd'
           WHEN repeat = '2' and everyweek =  '0'   THEN 'w'
           WHEN repeat = '2' and everyweek <> '0'   THEN 'm'
           WHEN repeat = '3'                        THEN 'm'
           WHEN repeat = '4'                        THEN 'r'
           WHEN repeat = '5' and intervalkind = 'd' THEN 'd'
           WHEN repeat = '5' and intervalkind = 'w' THEN 'w'
           WHEN repeat = '5' and intervalkind = 'm' THEN 'm'
           WHEN repeat = '5' and intervalkind = 'y' THEN 'y' ELSE NULL END) AS repeat
 ,   SCHEDULE.memo      AS memo
 ,   SCHEDULE.event     AS event
 ,   SCHEDULE.detail    AS detail
 ,   SCHEDULE.place     AS place
 ,   SCHEDULE.other     AS other
 ,   SCHEDULE.outflg    AS outflg
 ,   SCHEDULE.openlevel AS openlevel
 ,   SCHEDULE.rankflg   AS rankflg
 ,   SCHEDULE.reserve   AS reserve
 ,   SCHEDULE.flag      AS flag
 ,   SCHEDULE.visitor   AS visitor
 ,   SCHEDULE.iconno    AS iconno
 ,   ICON.Name          AS iconname
 ,   ICON.filename      AS iconfilename
 -- 付箋用
 ,   TAG.SID_MODULE     AS TAG_SID_MODULE
 ,   TAG.ID             AS TAG_ID
 ,   TAG.tagcolor       AS TAG_tagcolor
 -- アラーム用
 ,   ALARM.ID           AS ALARM_ID
 ,   ALARM.SID_MENU     AS ALARM_SID_MENU
 ,   ALARM.SENDTIME     AS ALARM_SENDTIME
 ,   ALARM.STATUS       AS ALARM_STATUS
 ,   ALARM.NAME         AS ALARM_NAME
 ,   ALARM.MEMO         AS ALARM_MEMO
 -- ログ出力用
 ,   CAST('User Schedule' as varchar(128)) AS LOG_KBN
 ,   SCHEDULE.SID_USER AS LOG_TID
 ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
 ,   SCHEDULE.ID AS LOG_SCH_ID
 ,   startdate AS LOG_startdate
 ,   starttime AS LOG_starttime
 from
    TTPR_SCHEDULE      SCHEDULE
 left join TMPR_TAG    TAG
 on  SCHEDULE.SID_CORPORATE = TAG.SID_CORPORATE
 and SCHEDULE.SID_USER      = TAG.SID_USER
 and SCHEDULE.ID            = TAG.DID
 and TAG.SID_MODULE         = CAST(1 as numeric(9))
 left join TM_SCH_ICON ICON
 on  SCHEDULE.SID_CORPORATE = ICON.SID_CORPORATE
 and SCHEDULE.iconno        = ICON.ID
 left join (
     select
         TT_ALARM.*
     from
         TT_ALARM
     inner join (
         select
            SID_CORPORATE
         ,  SID_USER
         ,  DID
         ,  SID_MENU
         ,  MAX(ID) AS ID
         from
            TT_ALARM
         group by
            SID_CORPORATE
         ,  SID_USER
         ,  DID
         ,  SID_MENU) MAX_ALARM
     on  TT_ALARM.SID_CORPORATE = MAX_ALARM.SID_CORPORATE
     and TT_ALARM.SID_USER      = MAX_ALARM.SID_USER
     and TT_ALARM.DID           = MAX_ALARM.DID
     and TT_ALARM.SID_MENU      = MAX_ALARM.SID_MENU
     and TT_ALARM.ID            = MAX_ALARM.ID
     ) ALARM
 on  SCHEDULE.SID_CORPORATE = ALARM.SID_CORPORATE
 and SCHEDULE.SID_USER      = ALARM.SID_USER
 and SCHEDULE.ID            = ALARM.DID
 and ALARM.SID_MENU         = CAST(1 as numeric(9))
 left join (
     select
         SID_CORPORATE   AS REP_SID_CORPORATE
     ,   SID_USER        AS REP_SID_USER
     ,   ID              AS REP_ID
     ,   max(SID_ASSIGN) AS REP_MAX_SID_ASSIGN
     from
         TTPR_SCH_REPDATE
     group by
         SID_CORPORATE
     ,   SID_USER
     ,   ID
     ) REP
 on  SCHEDULE.SID_CORPORATE = REP.REP_SID_CORPORATE
 and SCHEDULE.SID_USER      = REP.REP_SID_USER
 and SCHEDULE.ID            = REP.REP_ID
 where
     SCHEDULE.SID_CORPORATE = 1
 and (SCHEDULE.srctype IS NULL or SCHEDULE.srctarget IS NULL or SCHEDULE.srctype IN ('u', 'g', 'p'))
 and SCHEDULE.startdate > '19700102'
 and SCHEDULE.startdate < '21000101'
 and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')
