select 
     SID_CORPORATE
 ,   ID
 ,   SID_ASSIGN
 ,   starttime
 ,   endtime
 ,   deldates
 ,   cretime
 ,   entrytime AS updtime
 ,   (CASE WHEN repeat = '1'                        THEN 'd'
           WHEN repeat = '2' and everyweek =  '0'   THEN 'w'
           WHEN repeat = '2' and everyweek <> '0'   THEN 'm'
           WHEN repeat = '3'                        THEN 'm'
           WHEN repeat = '4'                        THEN 'r'
           WHEN repeat = '5' and intervalkind = 'd' THEN 'd'
           WHEN repeat = '5' and intervalkind = 'w' THEN 'w'
           WHEN repeat = '5' and intervalkind = 'm' THEN 'm'
           WHEN repeat = '5' and intervalkind = 'y' THEN 'y' ELSE NULL END) AS repeat
 ,   LOG_KBN
 ,   LOG_TID
 ,   LOG_SID_PRGROUP
 ,   LOG_SCH_ID
 ,   LOG_startdate
 ,   LOG_starttime
 ,   event
 ,   detail
 ,   LOG_repdate
 from
     (
     -- ユーザスケジュール
     select
         REPDATE.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_USER as varchar), 6, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 5, '0') || '1' AS ID
     ,   REPDATE.SID_ASSIGN
     ,   REPDATE.deldates
     ,   SCHEDULE.cretime
     ,   SCHEDULE.entrytime
     ,   SCHEDULE.starttime
     ,   SCHEDULE.endtime
     ,   SCHEDULE.repeat
     ,   SCHEDULE.everyweek
     ,   SCHEDULE.intervalkind
     ,   CAST('User Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_USER     AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     ,   REPDATE.SID_ASSIGN    AS LOG_repdate
     from
         TTPR_SCH_REPDATE     REPDATE
     inner join TTPR_SCHEDULE SCHEDULE
     on  REPDATE.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and REPDATE.SID_USER      = SCHEDULE.SID_USER
     and REPDATE.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and (   SCHEDULE.srctype IS NULL
         or  SCHEDULE.srctarget IS NULL
         or (SCHEDULE.srctype = 'u' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
         or (SCHEDULE.srctype = 'g' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
         or (SCHEDULE.srctype = 'p' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
         )
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')

     union all

     -- グループスケジュール
     select
         REPDATE.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_GROUP as varchar), 6, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 5, '0') || '2' AS ID
     ,   REPDATE.SID_ASSIGN
     ,   REPDATE.deldates
     ,   SCHEDULE.cretime
     ,   SCHEDULE.entrytime
     ,   SCHEDULE.starttime
     ,   SCHEDULE.endtime
     ,   SCHEDULE.repeat
     ,   SCHEDULE.everyweek
     ,   SCHEDULE.intervalkind
     ,   CAST('Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_GROUP    AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     ,   REPDATE.SID_ASSIGN    AS LOG_repdate
     from
         TT_SCH_GROUP_REPDATE REPDATE
     inner join TT_SCH_GROUP  SCHEDULE
     on  REPDATE.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and REPDATE.SID_GROUP     = SCHEDULE.SID_GROUP
     and REPDATE.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and (   SCHEDULE.srctype IS NULL
         or  SCHEDULE.srctarget IS NULL
         or (SCHEDULE.srctype = 'u' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
         or (SCHEDULE.srctype = 'g' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
         or (SCHEDULE.srctype = 'p' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
         )
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')

     union all

     -- 個人グループスケジュール
     select
         REPDATE.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_USER as varchar), 6, '0') || LPAD(CAST(SCHEDULE.SID_PRGROUP as varchar), 2, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 3, '0') || '3' AS ID
     ,   REPDATE.SID_ASSIGN
     ,   REPDATE.deldates
     ,   SCHEDULE.cretime
     ,   SCHEDULE.entrytime
     ,   SCHEDULE.starttime
     ,   SCHEDULE.endtime
     ,   SCHEDULE.repeat
     ,   SCHEDULE.everyweek
     ,   SCHEDULE.intervalkind
     ,   CAST('User Group Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_USER     AS LOG_TID
     ,   SCHEDULE.SID_PRGROUP  AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     ,   REPDATE.SID_ASSIGN    AS LOG_repdate
     from
         TTPR_SCH_GROUP_REPDATE REPDATE
     inner join TTPR_SCH_GROUP  SCHEDULE
     on  REPDATE.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and REPDATE.SID_USER      = SCHEDULE.SID_USER
     and REPDATE.SID_PRGROUP   = SCHEDULE.SID_PRGROUP
     and REPDATE.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and SCHEDULE.srctype IS NULL
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')

     union all

     -- 設備予約
     select
         REPDATE.SID_CORPORATE
     ,   SUBSTRING(SCHEDULE.startdate,3, 6)||LPAD(CAST(SCHEDULE.SID_PLANT as varchar), 6, '0') || LPAD(CAST(SCHEDULE.ID as varchar), 5, '0') || '4' AS ID
     ,   REPDATE.SID_ASSIGN
     ,   REPDATE.deldates
     ,   SCHEDULE.cretime
     ,   SCHEDULE.entrytime
     ,   SCHEDULE.starttime
     ,   SCHEDULE.endtime
     ,   SCHEDULE.repeat
     ,   SCHEDULE.everyweek
     ,   SCHEDULE.intervalkind
     ,   CAST('Plant Schedule' as varchar(128)) AS LOG_KBN
     ,   SCHEDULE.SID_PLANT    AS LOG_TID
     ,   CAST(NULL as numeric(9)) AS LOG_SID_PRGROUP
     ,   SCHEDULE.ID           AS LOG_SCH_ID
     ,   SCHEDULE.startdate    AS LOG_startdate
     ,   SCHEDULE.starttime    AS LOG_starttime
     ,   SCHEDULE.event
     ,   SCHEDULE.detail
     ,   REPDATE.SID_ASSIGN    AS LOG_repdate
     from
         TT_PLT_SCH_REPDATE     REPDATE
     inner join TT_PLT_SCHEDULE SCHEDULE
     on  REPDATE.SID_CORPORATE = SCHEDULE.SID_CORPORATE
     and REPDATE.SID_PLANT     = SCHEDULE.SID_PLANT
     and REPDATE.ID            = SCHEDULE.ID
     where
         SCHEDULE.SID_CORPORATE = 1
     and (   SCHEDULE.srctype IS NULL
         or  SCHEDULE.srctarget IS NULL
         or (SCHEDULE.srctype = 'u' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_USER  WHERE SID_CORPORATE = 1))
         or (SCHEDULE.srctype = 'g' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_GROUP WHERE SID_CORPORATE = 1))
         or (SCHEDULE.srctype = 'p' and SCHEDULE.srctarget NOT IN (SELECT ID FROM TM_PLANT WHERE SID_CORPORATE = 1))
         )
     and SCHEDULE.startdate > '19700102'
     and SCHEDULE.startdate < '21000101'
     and not(SCHEDULE.enddate IS NULL and SCHEDULE.startdate > '20371231')
     ) alias
