select 
     SID_CORPORATE
 ,   ID
 ,   Name
 ,   Tel
 ,   Memo
 ,   CONST_ID
 ,   ORGCONST_ID
 ,   CONST_LVL
 from
     (
     select
         BASE.SID_CORPORATE
     ,   BASE.ID
     ,   BASE.Name
     ,   BASE.Tel
     ,   BASE.Memo
     ,   BASE.CONST_ID
     ,   BASE.ORGCONST_ID
     ,   LV00.SEQNO as lvl0seqno
     ,   LV01.SEQNO as lvl1seqno
     ,   LV02.SEQNO as lvl2seqno
     ,   LV03.SEQNO as lvl3seqno
     ,   LV04.SEQNO as lvl4seqno
     ,   LV05.SEQNO as lvl5seqno
     ,   LV06.SEQNO as lvl6seqno
     ,   LV07.SEQNO as lvl7seqno
     ,   LV08.SEQNO as lvl8seqno
     ,   LV09.SEQNO as lvl9seqno
     ,   LV10.SEQNO as lvl10seqno
     ,   (CASE WHEN LENGTH(BASE.CONST_ID)<= 12 THEN 1 ELSE (LENGTH(BASE.CONST_ID) - 9) / 3 END) 
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 1 AND LV01.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 2 AND LV02.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 3 AND LV03.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 4 AND LV04.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 5 AND LV05.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 6 AND LV06.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 7 AND LV07.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 8 AND LV08.CONST_ID IS NULL THEN 1 ELSE 0 END)
        -(CASE WHEN (LENGTH(BASE.CONST_ID) - 9) / 3 > 9 AND LV09.CONST_ID IS NULL THEN 1 ELSE 0 END) AS CONST_LVL
     ,   (CASE WHEN LENGTH(BASE.CONST_ID)<= 12 THEN 1 ELSE (LENGTH(BASE.CONST_ID) - 9) / 3 END) AS ORG_CONST_LVL
     from
         TM_GROUP AS BASE
         left join (select SEQNO,CONST_ID,ID from TM_GROUP where CONST_ID is NULL ) LV00 ON BASE.ID=LV00.ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 12) LV01 ON SUBSTRING(BASE.CONST_ID, 1, 12) = LV01.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 15) LV02 ON SUBSTRING(BASE.CONST_ID, 1, 15) = LV02.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 18) LV03 ON SUBSTRING(BASE.CONST_ID, 1, 18) = LV03.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 21) LV04 ON SUBSTRING(BASE.CONST_ID, 1, 21) = LV04.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 24) LV05 ON SUBSTRING(BASE.CONST_ID, 1, 24) = LV05.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 27) LV06 ON SUBSTRING(BASE.CONST_ID, 1, 27) = LV06.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 30) LV07 ON SUBSTRING(BASE.CONST_ID, 1, 30) = LV07.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 33) LV08 ON SUBSTRING(BASE.CONST_ID, 1, 33) = LV08.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 36) LV09 ON SUBSTRING(BASE.CONST_ID, 1, 36) = LV09.CONST_ID
         left join (select SEQNO,CONST_ID from TM_GROUP where LENGTH(CONST_ID) = 39) LV10 ON SUBSTRING(BASE.CONST_ID, 1, 39) = LV10.CONST_ID
     where
         BASE.SID_CORPORATE = 1
     ) alias
 order by
     COALESCE(lvl0seqno,COALESCE(lvl1seqno,999999999))
 ,   (CASE WHEN ORG_CONST_LVL > 1 THEN COALESCE(lvl2seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 2 THEN COALESCE(lvl3seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 3 THEN COALESCE(lvl4seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 4 THEN COALESCE(lvl5seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 5 THEN COALESCE(lvl6seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 6 THEN COALESCE(lvl7seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 7 THEN COALESCE(lvl8seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 8 THEN COALESCE(lvl9seqno,999999999) ELSE 0 END)
 ,   (CASE WHEN ORG_CONST_LVL > 9 THEN COALESCE(lvl10seqno,999999999) ELSE 0 END)
 ;
